#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std ;
#include <stdlib.h>
#include "IntFamily.h"
#include "ParseFamily.h"
#include "GTNode.h"

#define FAMSLOTS 1000000

main(int argc, char *argv[])
{
  vector<IntFamily> *parsedFamilies ;
  if (argc==1)
    parsedFamilies = ParseFamily(&cin) ;
  else
  {
    ifstream myFInput(argv[1]) ;
    if (myFInput.bad())
    {
      cerr << "Unable to open " << argv[1] << endl ;
      exit(1) ;
    }
    parsedFamilies = ParseFamily(&myFInput) ;
    myFInput.close() ;
  }

  GTNode<int> **IntPeople = new GTNode<int> *[FAMSLOTS] ;
  for (int i=0; i<FAMSLOTS; ++i)	// whew....
    IntPeople[i] = (GTNode<int> *)NULL;

  // Create the first born
  IntPeople[1] = new GTNode<int>(1) ;
  vector<IntFamily>::iterator ptrFamily ;
  for (ptrFamily = parsedFamilies->begin() ;
       ptrFamily != parsedFamilies->end() ;
       ++ptrFamily )
  {
    // Get the node for the parent
    int intParent = ptrFamily->getParent() ;
    GTNode<int> *nodeParent = IntPeople[intParent] ;

    // Create the nodes for the children
    int numChildren = ptrFamily->getSize() ;
    for (int i=numChildren-1; i>=0; --i)
    {
      int intChild = ptrFamily->getChild(i) ;
      IntPeople[intChild] = new GTNode<int>(intChild) ;
      nodeParent->insert_first(IntPeople[intChild]) ;
    }
  }

  delete parsedFamilies ;

  // Print the ancestry
  for (int i=0; i<FAMSLOTS; ++i)
    if (IntPeople[i] != NULL)
    {
      GTNode<int> *nodePres = IntPeople[i] ;
      while (nodePres->parent() != NULL)
      {
	cout << nodePres->value() << " <- " ;
	nodePres = nodePres->parent() ;
      }
      cout << nodePres->value() << endl ;
    }

}
